;
;  D48 V3.3.6 8048 Disassembly of DVK-3_KBD_K573RF2.bin
;  05/20/18 20:06
;
;
; 0x20 - 
; 0x21 - port1 last state?
; 0x22 - 
			22,3 - click enabled
			22,4 - beep enabled
			
			
; 0x23 - 0,1 - Keyboard output port number
; 0x25 - 
			25,1 - BEEEEP requested
;			25,3 - data output disabled
;			25,4 - keyboard click requested? Beep enabled?

; 0x2F - Code of pushed button?
; 0x30 - Code of sent symbol?
; 0x36 - 
;			36,0 - 1 - CY has been pushed(ctrl)
;			36,1 - Shift??
;			36,2 - 1 - BP has been pushed(shift)
; 
; 0x3A - Saves A in INT?
;
; rb1,r1 - rx bit counter?
; rb1,r2 - serial rx status?
;		r2,0 - led on request?
; rb1,r3 - multibyte instruction byte counter
; rb1,r6 - serial out data?
;
;	P24 - WAIT LED
;	P25 - LAT LED
;

	org	0			;Address 0 - program start after reset
;
	dis	i			;Disable interrupt
	jmp	X0133		;Jump to program start
;
;	------------------------------------------------
;			0x03 - external INT
;	------------------------------------------------
	jmp	X0400			;External interrupt (Serial) jump

	org	7
;----------------------------------------------------
;			0x07 - Internal timer INT.
;			       Soft serial receive
;----------------------------------------------------
	sel		rb1
	en		i			;Enable serial INT
	mov		r0,#3ah	
	mov		@r0,a		;Saves A into 0x3A
	mov		a,r2
	jz		X0017		;Ja R2=0 then stops timer and exits from INT
						;Ja R2=0 then does not wait for second Rx byte.
						
	djnz	r3,X001b	;Decrements R3 and if !=0 then exits from INT
						;R3 maybe multybyte instruction timeout
	mov		r2,#0		;Ja R3=0 tad R2=0
	mov		r6,#0b6h	
	call	X006c		;Tx send 0xB6. Input error code at multibyte timeout?
	
X0017:					;Byte received, stop timer.
	stop	tcnt
	mov		a,#0
	mov		t,a			;Timer=0
	
X001b:
	mov		r0,#3ah	
	mov		a,@r0		;Restores A and 0x3A
	retr				;Return from timer interrupt
	
;-------------------------------------------------------------------
;------- MEM INIT subroutine ---------------------------------------
;-------------------------------------------------------------------
;
X001f:
	mov		r1,#20h
	mov		r0,#20h
	
X0023:			;mem init - 0x20 - 0x40 = 0
	mov		@r0,#0
	inc		r0
	djnz	r1,X0023
	
	mov	r0,#0	;reg init - all 0
	mov	r1,#0
	mov	r2,#0
	mov	r3,#0
	mov	r4,#0
	mov	r5,#0
	mov	r6,#0
	mov	r7,#0
	sel	rb1
	mov	r0,#0
	mov	r1,#0
	mov	r2,#0
	mov	r3,#0
	mov	r4,#0
	mov	r5,#0
	mov	r6,#0
	mov	r7,#0
	sel	rb0
	retr
;
	org	68h
;

;---------------------------------------------------------
; Char send subroutine, continues as soft serial tx
;---------------------------------------------------------
;0x30 - tx data

X0068:					
	mov		r0,#30h
	mov		a,@r0
	mov		r6,a
	
;---------------------------------------------------------
; 			       Soft serial Tx
;				   Continues until byte transmitted
;---------------------------------------------------------
;r6 - tx data

X006c:
	mov		r0,#25h
	mov		a,@r0
	jb3		X0094		;If 25,3=1 then exits
						;Data output disabled.
	mov		r1,#21h
	mov		a,@r1
	anl		a,#7fh		21 clear 7. bit - Tx pin=0
	mov		@r1,a
	outl	p1,a		;Clears Tx. Start bit.
	mov		r7,#8		;Outputs 8 bits - loop
	
X007a:
	mov		r5,#1
	mov		r4,#15h
	call	X00c2		;Soft delay - Tx bit time
	mov		a,r6
	rr		a			;Serial out data shift??
	mov		r6,a
	anl		a,#80h		;Tests bit to be sent
	add		a,@r1
	outl	p1,a		;Sends bit
	djnz	r7,X007a	;Serial out loop end
	
	mov		r5,#1
	mov		r4,#17h
	call	X00c2		;Soft delay - stop bit?
	mov		a,#80h	
	add		a,@r1
	outl	p1,a
	mov		@r1,a		;Uart Tx=1, idle state.
X0094:
	retr
	
;When clears 25,3????????

;---------------------------
;---- END SERIAL TX --------
;---------------------------

X0095:		;D11 reset
	orl		p1,#10h
	anl		p1,#0efh
	retr
;
	org	0c2h


;------------------------------------------------------
;------------- Soft delay
;			   Delay values predetermined in R4 and R5
;------------------------------------------------------

X00c2:
	djnz	r4,X00c2
	djnz	r5,X00c2
	retr
	
;------------------------------------------------------
;	Key press click
;------------------------------------------------------

X00c7:				
	mov		r0,#22h
	mov		a,@r0
	jb3		X00ce		;Click enabled?
	jmp		X00dc		;If no - return

X00ce:
	mov		r1,#21h		;If yes - clickity clack!
	mov		a,#8
	add		a,@r1		;????????? Maybe it's possible to switch on unnecessary bit?
	outl	p1,a		;Out 1 to buzzer pin
	mov		r4,#7fh
	mov		r5,#1
	call	X00c2		;Soft delay
	mov		a,@r1		
	outl	p1,a		;Out 0 to buzzer pin
X00dc:
	retr				;Return after successful click
	
;------------------------------------------------------
;	Key press click end
;------------------------------------------------------

X00dd:
	mov		r0,#22h
	mov		a,@r0
	jb4		X00e4	;BEEP enabled? If no, exit beep function.
	jmp		X00f5	
;

;----------------------------------------
;------------ BEEEEEEEP -----------------
;----------------------------------------
X00e4:
	mov		r6,#0feh	;0xfe - period count of one BEEEEP
	mov		r1,#21h
X00e8:
	mov		a,@r1
	xrl		a,#8		;Invert beeper signal state
	outl	p1,a		;Out beeper signal
	mov		r4,#1eh
	mov		r5,#1
	call	X00c2		;Soft delay - BEEP period
	mov		@r1,a		;Saves port state into 0x21
	djnz	r6,X00e8	;Loop continues
X00f5:
	retr				;Returns from BEEP function	
;----------------------------------------

;----------------------------------------
;	#22 status reg bit clear subroutine
;	in:
;		r0 - bits to clear	
;----------------------------------------

X00f6:
	mov		r1,#22h
	mov		a,@r1
	orl		a,r0
	xrl		a,r0
	mov		@r1,a
	retr

;----------------------------------------

	org	115h

;--------------------------------
;	Soft serial RX subroutine
;	out:
;	r7 - received data
;--------------------------------
X0115:
	mov		r7,#0
	mov		a,r7	;A=0 (rx buffer)
	mov		r1,#8	;r1=8 (Rx bit count)
X011a:
	mov		r4,#15h
	mov		r5,#1
	call	X00c2	;Soft delay
	jni		X012a	;If received bit=0 then do nothing (buffer init ar 0)
	mov		a,r7
	orl		a,#1	;If received bit=1 then buffer LSB=1	
X0125:
	rr		a		;received data shift
	mov		r7,a	
	djnz	r1,X011a	;Receive loop end
	retr			;Return after successful receive
	
;
X012a:
	nop
	jmp		X0125

;--------------------------------

;--------------------------------
;	Subroutine that sets #22 (status) bits to one
;--------------------------------

X012d:
	mov		r1,#22h
	mov		a,@r1
	orl		a,r0
	mov		@r1,a
	retr

;--------------------------------

;---------------------------------------------------------------------------
;				Program starts here
;---------------------------------------------------------------------------

X0133:
						;Memory and peripherial init
						
	sel		rb0			;use rb0 for main program
	ent0	clk			;Enable timer OUT
	en		tcnti		;Enable timer INT
	orl		p1,#10h		;D11 reset for init
	anl		p1,#0efh
	orl		p2,#0f0h	;LED off
	orl		p1,#20h		;LED off
	
	
	call	X00e4		;BEEE
	call	X00e4		;EEP! (starting beep)
	anl		p2,#0fh		;LED on?
	anl		p1,#0dfh	;LED on?
	
	call	X001f		;mem&reg init
	mov		r1,#22h		;
	mov		@r1,#38h
	mov		r0,#21h		;
	mov		@r0,#0c0h
	
	;	INIT END
	;	MAIN LOOP START
	
X0150:
	jni		X0153		;If INT=0 (break condition, fault, disconnected cable
						;or receiving unexpected data), do not enable serial input INT
						
	en		i			;Enable external (serial) interrupt if RS232 idle

X0153:
	mov		r3,#8		;Mux loop variable

X0155:					;Row scan (MUX) loop start
	mov		r1,#23h
	mov		@r1,#3		;Saves port where to output  
	dec		r3			;Decrement loop variable
	mov		r0,#21h
	mov		a,@r0
	anl		a,#0f8h
	add		a,r3
	mov		@r0,a
	outl	p1,a		;P1 mux control out
	
X0162:
	mov		r2,#1		
	
X0164:
	call	X0324		;Sets keyboard outputs
	jnt1	X01fa		;If T==1 then button are pushed and reply pulse has been received
	orl		p1,#10h
	anl		p1,#0efh	;P14 pulse. D11 reset.
	mov		r4,#45h
	mov		r5,#2
	call	X00c2		;Soft delay - debounce?
	call	X0324		;Sets keyboard outputs
	jnt1	X01fa		;If T==1 then button are pushed and reply pulse has been received
	orl		p1,#10h
	anl		p1,#0efh	;P14 pulse. D11 reset.
	mov		r0,#2fh
	mov		a,@r0
	xrl		a,#3
	jz		X01ef
	nop
;
	org	187h
;
	movp3	a,@a		;Reads button code from the array
	mov		r6,a
	mov		r0,#30h
	mov		@r0,a		;Saves code into #30
	mov		a,r6
	jz		X01e2		;Code ==0?
	xrl		a,#0afh		;Jumps to sending Shift???	
	jz		X01cd		;If code = 0xAF CY (ctrl)(pushed)
	mov		a,r6
	xrl		a,#0aeh
	jz		X01d5		;If code = 0xAE BP (shift)(pushed)
	mov		r1,#28h
	mov		a,r6
	xrl		a,@r1		;Compares button code to #28 saturu. Autorepeat?
	jz		X01ef
	mov		r1,#29h
	mov		a,r6
	xrl		a,@r1		;Compares button code to #29 saturu. Autorepeat?
	jz		X01f6
	mov		r1,#2ah
	mov		a,r6
	xrl		a,@r1		;Compares button code to #2A saturu. Autorepeat?
	jz		X01f6
	mov		r0,#27h		;If pushed button does not mach 28,29,2A then continues here
	mov		@r0,#0bh
	mov		r1,#29h
	mov		r0,#2ah
	mov		a,@r1
	mov		@r0,a
	mov		r0,#28h
	mov		a,@r0
	mov		@r1,a
	mov		a,r6
	mov		@r0,a
	mov		r1,#2ch
	mov		r0,#2dh
	mov		a,@r1
	mov		@r0,a
	mov		r0,#2bh
	mov		a,@r0
	mov		@r1,a
	mov		a,r7
	mov		@r0,a
	mov		r0,#2fh
	inc		@r0
						;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	call	X0068		;Here sends button code
						;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
						
	jmp	X0282			;Loop
	
	
;
X01cd:
	mov		r0,#36h		;If CY has to be sent (0xAF) (ctrl)
	mov		a,@r0
	jb0		X01f6		;If ctrl has already been sent, it's not sent one more time
	inc		@r0			
	jmp		X01de		
;
X01d5:
	mov		r0,#36h		;If BP has to be sent (0xAE)
	mov		a,@r0
	jb2		X01f6		;If shift has already been sent, it's not sent one more time
	mov		a,@r0		
	add		a,#4
	mov		@r0,a
X01de:
	call	X0068
	jmp		X0282
	

X01e2:					;Executes this if code == 0?
	mov		r0,#36h
	mov		a,@r0
	jb1		X01f6		
	inc		@r0
	inc		@r0
	mov		r6,#0aeh
	call	X006c		
	jmp		X0282		
;
X01ef:
	mov		r0,#27h
	mov		a,@r0
	dec		a
	jz		X01f8
	mov		@r0,a
	
X01f6:	jmp	X0282
;
X01f8:	jmp	X029b
;
;----------- Executes this if there has been no reply pulse from keyboard (all buttons released)).

X01fa:
	orl		p1,#10h		;P14 pulse. D11 reset?
	anl		p1,#0efh
	call	X02ca		;Executes beeps and some other functions
	mov		r0,#36h
	mov		a,@r0
	jz		X0237
	rrc		a
	jnc		X0212
	mov		a,r7
	xrl		a,#0cfh
	jnz	X0212
	mov	a,@r0
	dec	a
	mov	@r0,a
	jmp	X0231
;
X0212:	mov	a,@r0
	rrc	a
	rrc	a
	rrc	a
	jnc	X0223
	mov	a,r7
	xrl	a,#0cch
	jnz	X0223
	mov	a,@r0
	xrl	a,#4
	mov	@r0,a
	jmp	X0231
;
X0223:	mov	a,@r0
	rrc	a
	rrc	a
	jnc	X0237
	mov	a,r7
	xrl	a,#9eh
	jnz	X0237
	mov	a,@r0
	xrl	a,#2
	mov	@r0,a
X0231:	mov	r6,#0b3h
	call	X006c		;Serial Tx 0xB3. All Ups code.
	jmp	X0282
;
X0237:	mov	r0,#2fh
	mov	a,@r0
	jz	X0282
	mov	r0,#2bh
	mov	a,@r0
	xrl	a,r7
	jnz	X025b
	mov	r1,#2ch
	mov	a,@r1
	mov	@r0,a
	mov	r0,#2dh
	mov	a,@r0
	mov	@r1,a
	mov	@r0,#0
	mov	r0,#29h
	mov	r1,#28h
	mov	a,@r0
	mov	@r1,a
	mov	r1,#2ah
	mov	a,@r1
	mov	@r0,a
	mov	@r1,#0
	jmp	X027d
;
	org	25bh
;
X025b:	mov	r0,#2ch
	mov	a,@r0
	xrl	a,r7
	jnz	X0271
	mov	r1,#2dh
	mov	a,@r1
	mov	@r0,a
	mov	@r1,#0
	mov	r0,#29h
	mov	r1,#2ah
	mov	a,@r1
	mov	@r0,a
	mov	@r1,#0
	jmp	X027d
;
X0271:	mov	r0,#2dh
	mov	a,@r0
	xrl	a,r7
	jnz	X0282
	mov	@r0,#0
	mov	r0,#2ah
	mov	@r0,#0
X027d:	mov	r0,#2fh
	mov	a,@r0
	dec	a
	mov	@r0,a
	
X0282:
	mov	a,r2	;
	jb3	X0289
	rl	a
	mov	r2,a
	jmp	X0164
	
;	Matrix column scan loop end
	
;
X0289:	mov	r1,#23h
	mov	a,@r1
	jz	X0293
	mov	a,@r1
	dec	a
	mov	@r1,a
	jmp	X0162		;Matrix row scan loop end
;
X0293:	mov	a,r3	;If loop variable==0 then begin next scanning loop
	jz	X0298
	jmp	X0155		;Row scan loop continue
;
X0298:	jmp	X0150	;Main loop end
;===============================================================
;===== MAIN LOOP END =================================
;===============================================================

	org	29bh
;
X029b:
	mov		a,r6
	xrl		a,#0bdh	;
	jz		X0282	
	mov		a,r6
	jb7		X02a5
	jmp		X0282
;
X02a5:	anl	a,#70h
	jz	X0282
X02a9:	mov	r0,#22h
	mov	a,@r0
	jb5	X02b0
	jmp	X0282
;
X02b0:
	mov		r6,#0b4h
	call	X006c		;Serial Tx 0xB4. Metronome code.
	call	X02ca
	call	X00c7		;Click
	call	X0324		;Sets keyboard output
	jnt1	X02c6
	call	X0095
	mov		r4,#0ffh
	mov		r5,#0fh
	call	X00c2	;Long soft delay
	jmp		X02a9
;
X02c6:	call	X0095
	jmp	X0282
;

X02ca:
	mov		r0,#25h
	mov		a,@r0
	jz		X02d5
	jb0		X02fc
	jb1		X02d6
	jb4		X02e2
X02d5:
	retr
;
X02d6:
	anl		a,#0fdh
	mov		@r0,a
	call	X00dd		;Beep if key pressed?
	retr
;
	org	2ddh
;
	mov		r6,#0bah
	call	X006c		;Serial Tx 0xBA. Mode Change Acknowledge.
	retr
;
X02e2:
	anl		a,#0efh
	mov		@r0,a
	call	X00c7		;Click
	retr
	
;
X02e8:	nop
	mov	r6,#1
	call	X006c		;Serial Tx 0x01
	mov	r4,#0ffh
	mov	r5,#1
	call	X00c2		;Soft Delay
	mov	r6,#0
	call	X006c		;Serial Tx 0x00
	retr
;
	org	2fch
;
X02fc:
	nop
	mov		r6,#1
	call	X006c		;Serial Tx 0x01
	mov		r5,#1
	mov		r4,#0ffh
	call	X00c2		;Soft delay
	mov		r6,#0
	call	X006c		;Serial Tx 0x00;
	mov		r5,#1
	mov		r4,#0ffh
	call	X00c2		;Soft delay
	call	X006c		;Serial Tx 0x00;
	mov		r5,#1
	mov		r4,#0ffh
	call	X00c2		;Soft delay
	call	X006c		;Serial Tx 0x00;
	anl		p2,#0fh
	call	X04eb
	mov		r0,#38h
	call	X012d
	retr

;----------------------------------
;------- KBD OUT SET --------------
;----------------------------------
;Columns

X0324:
	mov		a,r2
	jb0		X032f		;If R2.0=1 then R7=0x80
	jb1		X0333		;If R2.1=1 then R7=0x90
	jb2		X0337		;If R2.2=1 then R7=0xA0
	mov		r7,#0b0h	;If 0,1,2 zeroes then R7=0xB0
	jmp		X0339
X032f:
	mov		r7,#80h
	jmp		X0339
X0333:
	mov		r7,#90h
	jmp		X0339
X0337:
	mov		r7,#0a0h
	
X0339:
	mov		a,r3
	add		a,r7
	mov		r7,a
	mov		r1,#23h
	mov		a,@r1
	jb0		X0353
	jb1		X0349		;Determines which expander output should be set.
	mov		a,r2
	movd	p4,a
	mov		a,#0
	movd	p4,a
	retr

X0349:
	mov		a,r7
	add		a,#8
	mov		r7,a
	mov		a,r2
	movd	p5,a
	mov		a,#0
	movd	p5,a
	retr

X0353:
	jb1		X035f
	mov		a,r7
	add		a,#40h
	mov		r7,a
	mov		a,r2
	movd	p6,a
	mov		a,#0
	movd	p6,a
	retr

X035f:
	mov		a,r7
	add		a,#48h
	mov		r7,a
	mov		a,r2
	movd	p7,a
	mov		a,#0
	movd	p7,a
X0368:
	retr

;
;------------------------------------------------
;---------- END KBD OUT SET ---------------------
;------------------------------------------------

;------------------------------
;-------- DATA ARRAY -------------
;------------------------------
	org		369h
	
	db		00h,00h,00h,00h,00h,00h,00h,00h
	db		00h,00h,00h,00h,00h,00h,00h,00h
	db		00h,00h,00h,00h,00h,00h,00h,A2h
	db		81h,80h,A3h,98h,9Eh,9Bh,9Ah,A4h
	db		83h,82h,9Fh,95h,9Ch,94h,A0h,A1h
	db		FFh,7Dh,9Dh,92h,99h,97h,96h,BCh
	db		FFh,74h,C4h,FFh,BDh,00h,FFh,8Fh
	db		8Ch,7Dh,8Eh,FFh,FFh,A9h,A8h,F5h
	db		73h,72h,C9h,F1h,FAh,F7h,FDh,8Ah
	db		8Bh,7Ch,8Dh,FFh,AAh,A7h,FFh,EFh
	db		71h,FFh,F9h,CAh,F6h,FBh,F2h,E5h
	db		EAh,68h,F0h,F3h,ECh,EDh,E7h,FCh
	db		56h,57h,BFh,AEh,BEh,B0h,AFh,E0h
	db		67h,66h,E6h,E8h,EBh,E3h,E2h,C0h
	db		59h,58h,C1h,B1h,C6h,B2h,C2h,DCh
	db		DBh,65h,E1h,D4h,DDh,D9h,DEh,C5h
	db		FFh,5Ah,CCh,FFh,C7h,C3h,C8h,D7h
	db		D6h,64h,D8h,FFh,D2h,FFh,D3h,D0h
	db		CBh,FEh,D1h,FFh,CDh,FFh,CE

;-----------------------------------------------
;           END OF DATA ARRAY
;-----------------------------------------------
;			Serial in interrupt
;-----------------------------------------------
X0400:
	sel		rb1
	dis		i
	dis		tcnti
	mov		r0,#39h
	mov		@r0,a		;Save A in 0x39
	mov		r5,#1
	mov		r4,#8
	call	X00c2		;Soft delay
	jni		X0410		;If INT pin=0 (Rx data)
	jmp		X067d		
;
X0410:
	call	X0115		;Call soft serial receive
	mov		a,r7
	jb7		X0441		;If MSB of received byte=1, it means that ????
	mov		a,r7
	xrl		a,#23h		;Rx=0x23 - bell enabled?
	jnz		X0420		
	mov		r2,#8
	mov		r3,#0
	jmp		X0687
;
X0420:					;Rx!=0x23
	mov		a,r7
	xrl		a,#11h		;Rx==0x11 ?
	jnz		X042b		
	mov		r2,#2
	mov		r3,#0
	jmp		X0687
;
X042b:
	mov		a,r7
	xrl		a,#13h		;Rx=0x13
	jnz		X0436
	mov		r2,#1
	mov		r3,#0
	jmp		X0687
;
X0436:
	mov		a,r7
	xrl		a,#1bh		;Rx=0x1B - click enabled?
	jnz		X04e9
	mov		r2,#4
	mov		r3,#0
	jmp		X0687
;

X0441:
	jb6		X04ab		;Rx MSB=1 continues here
	xrl		a,#0a1h		;Rx==A1 - beep disabled?
	jnz		X044d
	mov		r0,#10h
	call	X00f6		;Disable beep
	jmp		X067a
;
X044d:
	mov		a,r7
	xrl		a,#99h		;Rx==99 - click disabled?
	jnz		X0458
	mov		r0,#8
	call	X00f6		;disable click
	jmp		X067a
;
X0458:
	mov		a,r7
	xrl		a,#0a7h		;Rx==0xA7 - BEEEEEEEEEP requested?
	jnz		X0465
	mov		r0,#25h
	mov		a,@r0
	orl		a,#2
	mov		@r0,a		;Mark that beep requested
	jmp		X067a
;
X0465:
	mov		a,r2
	jnz		X048f
	mov		a,r7
	xrl		a,#89h		;Rx==0x89 - data output disabled?
	jnz		X047c
	mov		r6,#0b7h
	call	X006c		;Serial Tx 0xB7. KBD locked acknowledge.
	mov		r0,#25h
	mov		a,@r0
	orl		a,#8
	mov		@r0,a
	orl		p2,#10h
	jmp		X067a
;
	org	47ch
;
X047c:
	mov		a,r7
	xrl		a,#8bh		;Rx=0x8B - data output enabled?
	jnz		X048f
	mov		r0,#25h
	mov		a,@r0
	anl		a,#0f7h
	mov		@r0,a
	anl		p2,#0efh	;LED - ???
	jmp		X067a
;
	org	48fh
;
X048f:
	mov		a,r7
	xrl		a,#9fh		;Rx==0x9F - clickity clack??
	jnz		X049c
	mov		r0,#25h
	mov		a,@r0
	orl		a,#10h
	mov		@r0,a
	jmp		X067a
;
X049c:
	mov		a,r7
	xrl		a,#0abh		;Rx=0xAB - ???
	jnz		X04e9
	mov		r4,#1fh
	mov		r5,#1
	call	X00c2		;Soft delay
	call	X02e8		;Serial output 0x01, 0x00. Should be 0xAA code.
	jmp		X067a
;
X04ab:	jb3	X04c4
	jb4	X04d2
	xrl	a,#0e1h
	jnz	X04b9
X04b3:	mov	r0,#20h
	call	X00f6
	jmp	X067a
;
X04b9:	mov	a,r7
	xrl	a,#0e3h
	jnz	X04e9
	mov	r0,#20h
	call	X012d
	jmp	X067a
;
X04c4:	xrl	a,#0fdh
	jnz	X04d2
	mov	r4,#1fh
	mov	r5,#1
	call	X00c2
	call	X02fc
	jmp	X067a
;
X04d2:	xrl	a,#0d3h
	jnz	X04e2
	mov	r4,#1fh
	mov	r5,#1
	call	X00c2
	mov	r6,#0bah
	call	X006c	;Serial Tx 0xBA. Mode Change Acknowledge. 
	jmp	X067a
;
X04e2:	mov	a,r7
	xrl	a,#0d9h
	jnz	X04e9
	jmp	X04b3
;
X04e9:	jmp	X05c0
;
X04eb:	mov	r0,#21h
	mov	a,@r0
	anl	a,#0dfh
	mov	@r0,a
	mov	r0,#25h
	mov	@r0,#0
	retr
;
	org	4f7h
;
	mov	r6,#1
	call	X006c	
	mov	r5,#1
	mov	r4,#0ffh
	call	X00c2
	mov	r6,#0
	call	X006c
	mov	r5,#1
	mov	r4,#0ffh
	call	X00c2
	call	X006c
	mov	r5,#1
	mov	r4,#0ffh
	call	X00c2
	call	X006c	;Serial Tx 0x01, 0x00, 0x00, 0x00
	anl	p2,#0fh
	call	X04eb
	mov	r0,#38h
	call	X012d
	retr
;
	org	531h
;
X0531:
	mov		a,r7
	jb7		X0536
	jmp		X05af	;If MSB==0 then exit INT
;
X0536:
	jb6		X05af	;If bit5 and 6==1 then exit INT
	jb5		X05af
	
	
	jb4		X056a	
	jb3		X0546	
	jb2		X054e
	jb1		X0554
	jb0		X058e	;0x81 - WAIT LED
	jmp		X05af	;If all 0 - exit INT
;
X0546:	jb2	X0558
	jb1	X055e
	jb0	X057e
	jmp	X059e
;
X054e:	jb1	X0562
	jb0	X0586
	jmp	X05a6
;
X0554:	jb0	X058a
	jmp	X05aa
;
X0558:	jb1	X0566
	jb0	X0576
	jmp	X0596
;
X055e:	jb0	X057a
	jmp	X059a
;
X0562:	jb0	X0582
	jmp	X05a2
;
X0566:	jb0	X0572
	jmp	X0592
;
X056a:					;Multibyte 0x90 received - LAT LED off 
	mov		r0,#21h
	mov		a,@r0
	anl		a,#0dfh
	mov		@r0,a		;Turn off LAT LED
	jmp		X05ac		;Exit INT

;------------------------------------------
;	LED off (?) subroutines
;------------------------------------------
X0572:	orl	p2,#0f0h
	jmp	X05ac
;
X0576:	orl	p2,#0d0h
	jmp	X05ac
;
X057a:	orl	p2,#0b0h
	jmp	X05ac
;
X057e:	orl	p2,#90h
	jmp	X05ac
;
X0582:	orl	p2,#70h
	jmp	X05ac
;
X0586:	orl	p2,#50h
	jmp	X05ac
;
X058a:	orl	p2,#30h
	jmp	X05ac
;
X058e:	orl	p2,#10h		;WAIT LED off
	jmp	X05ac
;
X0592:	orl	p2,#0e0h
	jmp	X05ac
;
X0596:	orl	p2,#0c0h
	jmp	X05ac
;
X059a:	orl	p2,#0a0h
	jmp	X05ac
;
X059e:	orl	p2,#80h
	jmp	X05ac
;
X05a2:	orl	p2,#60h
	jmp	X05ac
;
X05a6:	orl	p2,#40h
	jmp	X05ac
;
X05aa:	orl	p2,#20h
;----------------------------------------
;	END
;----------------------------------------

X05ac:
	mov		r2,#0		;Clears Rx status reg
	stop	tcnt		;Stops timeout timer
X05af:
	mov		r0,#39h		;Restore A from #0x39
	mov		a,@r0
	sel		rb0
	en		i			;Enables INTs
	en		tcnti
	retr				;Returns from INT
;
	org	5c0h
;
X05c0:				;Ends up here when all possible Rx data has been tested?
	mov		a,r2	
	jz		X05cb	;If Rx State=0 then exits INT
	jb0		X0531
	jb1		X05ff
	jb2		X05e2
	jb3		X05cd
X05cb:
	jmp		X067d
;
X05cd:
	mov		a,r7
	jb3		X05e0
	jb4		X05e0
	jb5		X05e0
	jb6		X05e0
	jb7		X05da
	jmp		X067d
;
X05da:
	mov		r0,#10h
	call	X012d
	mov		r2,#0
X05e0:
	jmp		X067a
;
X05e2:	mov	a,r7
	jb3	X05f5
	jb4	X05f5
	jb5	X05f5
	jb6	X05f5
	jb7	X05ef
	jmp	X067d
;
X05ef:	mov	r0,#8
	call	X012d
	mov	r2,#0
X05f5:	jmp	X067a
;
	org	5ffh
;


X05ff:	mov	a,r7
	jb7	X0604
	jmp	X067d
;
X0604:	jb6	X067d
	jb5	X067d
	jb4	X0638
	jb3	X0614
	jb2	X061c
	jb1	X0622
	jb0	X065c
	jmp	X067d
;
X0614:	jb2	X0626
	jb1	X062c
	jb0	X064c
	jmp	X066c
;
X061c:	jb1	X0630
	jb0	X0654
	jmp	X0674
;
X0622:	jb0	X0658
	jmp	X0678
;
X0626:	jb1	X0634
	jb0	X0644
	jmp	X0664
;
X062c:	jb0	X0648
	jmp	X0668
;
X0630:	jb0	X0650
	jmp	X0670
;
X0634:	jb0	X0640
	jmp	X0660
;
X0638:					;Multibyte 0x90 received - LAT LED off
	mov		r0,#21h
	mov		a,@r0
	orl		a,#20h
	mov		@r0,a		;Turn on LAT LED
	jmp		X067a		;Exit from INT
	
;-------------------------------------
;	LED on subroutines
;-------------------------------------
X0640:	anl	p2,#0fh
	jmp	X067a
;
X0644:	anl	p2,#2fh
	jmp	X067a
;
X0648:	anl	p2,#4fh
	jmp	X067a
;
X064c:	anl	p2,#6fh
	jmp	X067a
;
X0650:	anl	p2,#8fh
	jmp	X067a
;
X0654:	anl	p2,#0afh
	jmp	X067a
;
X0658:	anl	p2,#0cfh
	jmp	X067a
;
X065c:	anl	p2,#0efh
	jmp	X067a
;
X0660:	anl	p2,#1fh
	jmp	X067a
;
X0664:	anl	p2,#3fh
	jmp	X067a
;
X0668:	anl	p2,#5fh
	jmp	X067a
;
X066c:	anl	p2,#7fh
	jmp	X067a
;
X0670:	anl	p2,#90h
	jmp	X067a
;
X0674:	anl	p2,#0bfh
	jmp	X067a
;
X0678:	anl	p2,#0dfh
;------------------------------------
;	END
;------------------------------------


;		 Rx INT end
;
X067a:
	mov		r2,#0	;Marks Rx status Idle
	stop	tcnt	;Stops timeout timer
X067d:
	mov		r0,#39h
	mov		a,@r0	;Restores A contents
	sel		rb0
	en		tcnti
	en		i		;Enables INT
	retr
;-----------------------------
;	END Rx processing
;-----------------------------

;
	org	687h
;
X0687:
	jni		X0687
	mov		r3,#4
	strt	t		;Start timeout timer
	jmp		X067d	;Return from INT
	
	
;
	org	0eddh
;
X0edd:	db	0ffh
;
;	Miscellaneous equates
;
;  These are addresses referenced in the code but
;  which are in the middle of a multibyte instruction
;  or are addresses outside the initialized space
;
X0357	equ	357h
X03c2	equ	3c2h
X03e5	equ	3e5h
X04a0	equ	4a0h
;
	end
;

